use thiserror::Error;

#[derive(Error, Debug)]
pub(crate) enum Error {
    #[error("Hex FromHex Error {0}")]
    HexFromHex(#[from] hex::FromHexError),
    #[error("Url Parse error Error {0}")]
    UrlParse(#[from] url::ParseError),
    #[error("Io Error {0}")]
    Io(#[from] std::io::Error),
    #[error("Wicked Waifus Downloader Lib Error {0}")]
    WickedWaifusDownloaderLib(#[from] wicked_waifus_downloader_lib::Error),
    #[error("No more CDN available")]
    CdnListExhausted,
    #[error("CRC Mismatch, expected: {0}, got: {1}")]
    CrcMismatch(String, String),
    #[error("Length mismatch, expected: {0}, got: {1}")]
    LengthMismatch(u64, u64),
    #[error("Preload selected but no preload switch exist")]
    PreloadSwitchMissing,
    #[error("Preload selected but no preload data exist")]
    PreloadDataMissing,
}
