pub mod launcher;
pub mod game;
pub mod resources;

use serde::{Deserialize, Serialize};
use std::collections::HashMap;

pub type LanguageMap = HashMap<String, Option<String>>;

#[derive(Debug, Serialize, Deserialize)]
pub struct CdnInfo {
    #[serde(rename = "K1")]
    pub k1: u32,
    #[serde(rename = "K2")]
    pub k2: u32,
    #[serde(rename = "P")]
    pub p: u32,
    pub url: String,
}

#[derive(Serialize, Deserialize, Debug)]
#[serde(rename_all = "camelCase")]
pub struct Experiment {
    pub download: Option<ExperimentDownload>,
    #[serde(rename = "res_check")]
    pub res_check: Option<ExperimentResCheck>,
}

#[derive(Serialize, Deserialize, Debug)]
#[serde(rename_all = "camelCase")]
pub struct ExperimentDownload {
    pub download_read_block_timeout: Option<String>,
}

#[derive(Serialize, Deserialize, Debug)]
#[serde(rename_all = "camelCase")]
pub struct ExperimentResCheck {
    pub file_chunk_check_switch: Option<String>,
    pub file_size_check_switch: Option<String>,
    pub res_valid_check_time_out: Option<String>,
    pub file_check_white_list_config: Option<String>,
}